export function getTop (e: any) {
    let offset = e.offsetTop
    if (e.offsetParent !== null) offset += getTop(e.offsetParent)
    return offset
  }
  
  export function getLeft (e: any) {
    let offset = e.offsetLeft
    if (e.offsetParent !== null) offset += getLeft(e.offsetParent)
    return offset
  }
  
  export function clearEventBubble (e: { [x: string]: any; currentTarget?: any; clientX?: any; clientY?: any; stopPropagation?: any; cancelBubble?: any; preventDefault?: any; returnValue?: any }) {
    if (e.stopPropagation) e.stopPropagation()
    else e.cancelBubble = true
  
    if (e.preventDefault) e.preventDefault()
    else e.returnValue = false
  }
  
  export function getScroll (dom: string) {
    if(dom){
      let element = document.getElementById(dom)
      return {
        scrollLeft: element?.scrollLeft || 0,
        scrollTop: element?.scrollTop || 0
      }
    }else if (window.pageYOffset) {
      return {
        scrollLeft: window.pageXOffset,
        scrollTop: window.pageYOffset
      }
    } else if (document.compatMode === 'CSS1Compat') {
      return {
        scrollLeft: document.documentElement.scrollLeft,
        scrollTop: document.documentElement.scrollTop
      }
    }
  
    return {
      scrollLeft: document.body.scrollLeft,
      scrollTop: document.body.scrollTop
    }
  }
  
  export function isInPath (target: { offsetLeft: any; offsetTop: any; offsetWidth: any; offsetHeight: any }, wrapper: { left: number; top: number; width: any; height: any }) {
    const iOffLeft = target.offsetLeft
    const iOffTop = target.offsetTop
    const iLeft = target.offsetWidth + iOffLeft
    const iTop = target.offsetHeight + iOffTop
    if (iLeft > wrapper.left && iTop > wrapper.top && iOffLeft < (wrapper.left + wrapper.width) && iOffTop < (wrapper.top + wrapper.height)) {
      return true
    }
    return false
  }
  
  export function getParents (el: { parentNode: any }, parentTag: undefined) {
    if (parentTag === undefined) {
      return el.parentNode
    }
    let result = el.parentNode
    while (result.tagName !== parentTag) {
      let o = result
      result = o.parentNode
    }
  
    return result
  }

export function getElementsClass(className: string){ 
  let classobj= [];
  let classint=0;
  let tags = document.getElementsByTagName("*");
  for(let i in tags){
    if(tags[i].nodeType === 1){
      let classTag = tags[i].getAttribute("class") || ''
      let classArray = classTag.split(' ')
      if(classArray.indexOf(className) !== -1 ){ 
        classobj[classint]=tags[i]; 
        classint++; 
      } 
    }
  } 
  return classobj;
}

export function isEqual(a: { [x: string]: any }, b: { [x: string]: any }) {
  let Equal = true
  if(a !== null && b !== null && (typeof a) === 'object' && (typeof b) === 'object'){
    let aProps = Object.getOwnPropertyNames(a);
    let bProps = Object.getOwnPropertyNames(b);
    if (aProps.length !== bProps.length) {
        Equal = false;
        return Equal
    }
    // eslint-disable-next-line @typescript-eslint/prefer-for-of
    for (let i = 0; i < aProps.length; i++) {
      let propName = aProps[i]
      let propA = a[propName]
      let propB = b[propName]
      if((typeof propA) === 'object' && (typeof propB) === 'object'){
        if(!isEqual(propA, propB)){
          Equal = false;
          return Equal
        }
      }else if(propA !== propB){
        Equal = false
        return Equal
      }
    }
  }else if(a !== b){
    Equal = false
    return Equal
  }
  return Equal
}
