const path = require('path');
const { CleanWebpackPlugin } = require('clean-webpack-plugin');

module.exports = {
  mode: 'production',

  entry: {
    index: './src/index.ts'
  },

  output: {
    filename: '[name].js',
    path: path.resolve(__dirname, "dist"),
    libraryTarget: 'commonjs2'
  },

  resolve: {
    extensions: [ '.tsx', '.ts', '.js', '.jsx' ]
  },

  module: {
    rules: [
      {
        test: /\.(ts|tsx)$/,
        loader: 'ts-loader',
        exclude: /node_module/
      },
      {
        test: /\.css$/,
        use: ['style-loader','css-loader']
      }
    ]
  },


  plugins: [
    new CleanWebpackPlugin()
  ]
}